--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/debug-macro.S	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/debug-macro.S	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,18 @@
+/*
+ * Debugging macro for Cavium CNC1900 Platform
+ * Author: xiaodong fan
+ *
+ * This file is licensed under
+ * the terms of the GNU General Public License version 2. This program
+ * is licensed "as is" without any warranty of any kind, whether express
+ * or implied.
+ */
+#include <mach/hardware.h>
+
+	.macro  addruart, rp, rv, tmp
+	ldr	\rp, =CNC1900_UART0				@ physical
+	ldr	\rv, =IO_ADDRESS(CNC1900_UART0)	@ virtual
+	.endm
+
+#define UART_SHIFT 2
+#include <asm/hardware/debug-8250.S>
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/hardware.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/hardware.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/hardware.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/hardware.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,19 @@
+/*
+ *  arch/arm/mach-celestial/include/mach/hardware.h
+ *
+ *  This file contains the hardware definitions of the Cavium CNC1900 Platform.
+ *
+ *  Copyright (C) 2012 Cavium 
+ *  Author: Xaodong Fan <xiaodong.fan@cavium.com>
+ */
+#ifndef __ASM_ARCH_HARDWARE_H
+#define __ASM_ARCH_HARDWARE_H
+
+#include <mach/cnc1900.h>
+
+/* macro to get at IO space when running virtually */
+#define IO_ADDRESS(phys) (0xF0000000 + ((((phys) >> 4) & 0x0ff00000) + ((phys) & 0xFFFFFFF)))
+ 
+#endif
+
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/irqs.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/irqs.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/irqs.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/irqs.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,68 @@
+/*
+ *  linux/arch/arm/mach-celestialsemi/include/mach/irqs.h
+ *
+ *  Copyright (C) 2013 Cavium  
+
+ *  Author: Jia Ma <jma@caviumnetworks.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef __ASM_ARM_ARCH_IRQ_H
+#define __ASM_ARM_ARCH_IRQ_H
+
+#define NR_IRQS        96
+
+#define CPU_PRI_TIMER_IRQ  29
+#define CPU_WDT_TIMER_IRQ  30
+#define CPU_PMU_IRQ		51
+#define EX_IRQ_PCMCIA_IRQ	52
+#define PCMCIA_IRQ	53
+#define GPIO_IRQ		54
+#define SPI_IRQ        55
+#define SECURITY_CORE_IRQ	56
+#define SD0_IRQ        57
+#define SD1_IRQ        58
+#define EHCI_IRQ	59
+#define CRYPTO_IRQ	60
+#define OHCI_IRQ	61
+#define READY_PCMCIA_N_IRQ		62
+#define IREQ_PCMCIA_N_IRQ		63
+#define HDMI_IRQ		64
+#define OTG_IRQ		65
+#define DISP2_IRQ	66
+#define DISP1_IRQ	67
+#define VIDEO_IRQ	68
+#define AUDIO_IRQ	69
+#define ETH0_IRQ       70
+#define XPORT_IRQ2	71
+#define XPORT_IRQ1	72
+#define IR_IRQ		73
+#define PANEL_CONTROL_IRQ		74
+#define I2C0_IRQ     75
+#define I2C1_IRQ       76
+#define UART1_IRQ      77
+#define UART0_IRQ      78
+#define SMART_CARD_IRQ		79
+#define GFX_IRQ		80
+#define CLKSET_IRQ	81
+#define ETH1_IRQ       83
+#define TZASC1		93
+#define TZASC0		94
+#define SECURE_TIMER_IRQ	95
+
+#define IRQ_CRYPTO_ENG 26
+
+#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/mem_define.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/mem_define.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/mem_define.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/mem_define.h	2015-06-19 15:58:42.412211000 +0800
@@ -0,0 +1,256 @@
+#ifndef __ARCH_MEM_DEF_H
+#define __ARCH_MEM_DEF_H
+
+//#define SW_FEED_VIDEO
+
+#if defined(CONFIG_CELESTIAL_HDK) ||defined(CONFIG_CELESTIAL_EVB) ||defined(CONFIG_CELESTIAL_OTT_EMMC)
+#ifdef CONFIG_SW_SUPPORT
+#define CELESTIAL_MEM_SIZE 480
+//#define AUDIO_ALIGN_GAP 0x0
+//#define AUDIO_PTS_FIXED_SIZE 0x0
+#else
+#define CELESTIAL_MEM_SIZE 512
+//#define AUDIO_ALIGN_GAP 0x100
+//#define AUDIO_PTS_FIXED_SIZE 0x100000
+#endif
+#elif defined(CONFIG_CELESTIAL_FJ_RX) || defined(CONFIG_CELESTIAL_FJ_TX)
+#define CELESTIAL_MEM_SIZE 256
+//#define AUDIO_ALIGN_GAP 0x100
+//#define AUDIO_PTS_FIXED_SIZE 0x100000
+#else
+#ifdef CONFIG_SW_SUPPORT
+#define CELESTIAL_MEM_SIZE 480
+//#define AUDIO_ALIGN_GAP 0x0
+//#define AUDIO_PTS_FIXED_SIZE 0x0
+#else
+#define CELESTIAL_MEM_SIZE 512
+//#define AUDIO_ALIGN_GAP 0x100
+//#define AUDIO_PTS_FIXED_SIZE 0x100000
+#endif
+#endif
+
+#define AUDIO_ALIGN_GAP 0x100
+#define AUDIO_PTS_FIXED_SIZE 0x100000
+
+#define        BASE_DDR_ADDR          0x10000000
+
+#ifdef CONFIG_FB0_SIZE
+#define        FB0_SIZE                   CONFIG_FB0_SIZE
+#else
+#define        FB0_SIZE                   0x1000000
+#endif
+#define        FB0_REGION             (BASE_DDR_ADDR - FB0_SIZE)
+#ifdef CONFIG_FB1_SIZE
+#define        FB1_SIZE               CONFIG_FB1_SIZE
+#else
+#define        FB1_SIZE               0x1000000
+#endif
+#define        FB1_REGION             (FB0_REGION - FB1_SIZE)
+
+#ifdef CONFIG_FB2_SIZE
+#define        FB2_SIZE               CONFIG_FB2_SIZE
+#else
+#define        FB2_SIZE               0x800000
+#endif
+#define        FB2_REGION             (FB0_REGION + FB0_SIZE - FB2_SIZE)
+
+#ifdef CONFIG_FB3_SIZE
+#define        FB3_SIZE               CONFIG_FB3_SIZE
+#else
+#define        FB3_SIZE               0x800000
+#endif
+#define        FB3_REGION             (FB1_REGION + FB1_SIZE - FB3_SIZE)
+
+#define        BLOB_SIZE              0x100000
+#define        BLOB_BASE              (FB1_REGION-BLOB_SIZE)
+
+#define        GPU_SIZE      		  0x2000000
+#define        GPU_BASE     		  (BLOB_BASE-GPU_SIZE)
+
+//for scalor coef data
+#define        SCALOR_COEF_SIZE       (0x2000*3)
+#define        SCALOR_COEF_REGION     (GPU_BASE-SCALOR_COEF_SIZE)
+
+#ifdef CONFIG_SW_SUPPORT 
+#define		CRYPTO_MEM_SIZE 0x0
+#else
+#define        CRYPTO_MEM_SIZE        0x300000
+#endif
+#define        CRYPTO_MEM_REGION      (SCALOR_COEF_REGION - CRYPTO_MEM_SIZE)
+
+#define        VIDEO_STUFF_SIZE       (0x400000)
+#define        VIDEO_STUFF_REGION     (CRYPTO_MEM_REGION - VIDEO_STUFF_SIZE)
+
+#if (defined CONFIG_SW_SUPPORT) && (defined SW_FEED_VIDEO)
+#define        VIDEO_NUM              (1)
+#define        VIDEO_DPB_SIZE         (0x0)
+#define        VIDEO_DPB_REGION       (VIDEO_STUFF_REGION - VIDEO_DPB_SIZE)
+#define        VIDEO_CPB_SIZE         (0x0 * VIDEO_NUM)
+#define        VIDEO_CPB_REGION       (VIDEO_DPB_REGION - VIDEO_CPB_SIZE)
+#define        VIDEO_CPB_DIR_SIZE     (0x0)
+#define        VIDEO_CPB_DIR_REGION   (VIDEO_CPB_REGION - VIDEO_CPB_DIR_SIZE)
+
+#ifdef CONFIG_VIDEO_ENC_NUM
+#define        VIDEO_ENC_NUM              CONFIG_VIDEO_ENC_NUM
+#else
+#define        VIDEO_ENC_NUM              0
+#endif
+
+#ifdef CONFIG_VIDEO_ENC_CPB_SIZE
+#define        VIDEO_ENC_CPB_SIZE     (CONFIG_VIDEO_ENC_CPB_SIZE * VIDEO_ENC_NUM)
+#else
+#define        VIDEO_ENC_CPB_SIZE     (0x400000 * VIDEO_ENC_NUM)
+#endif
+
+#define        VIDEO_ENC_CPB_REGION   (VIDEO_CPB_DIR_REGION - VIDEO_ENC_CPB_SIZE)
+#define        VIDEO_ENC_DIR_SIZE     (VIDEO_ENC_CPB_SIZE/0x100)
+#define        VIDEO_ENC_DIR_REGION   (VIDEO_ENC_CPB_REGION - VIDEO_ENC_DIR_SIZE)
+
+#define        VIDEO_USER_DATA_SIZE   (0x0 * VIDEO_NUM)
+#define        VIDEO_USER_DATA_REGION (VIDEO_ENC_DIR_REGION - VIDEO_USER_DATA_SIZE)
+
+#else
+
+#ifdef CONFIG_VIDEO_NUM
+#define        VIDEO_NUM              CONFIG_VIDEO_NUM
+#else
+#define        VIDEO_NUM              0
+#endif
+#if defined(CONFIG_CELESTIAL_FJ_RX) || defined(CONFIG_CELESTIAL_FJ_TX)
+//#define        VIDEO_DPB_SIZE         (0x1e9c000) // ((2048*1088*1.8 + 2047) >> 11 << 11) * 12
+#define        VIDEO_DPB_SIZE           (0x2ded000) // ((2048*1088*1.8 + 2047) >> 11 << 11) * 12
+#elif defined(CONFIG_CELESTIAL_HDK) || defined(CONFIG_CELESTIAL_OTT_EMMC)
+#define        VIDEO_DPB_SIZE         (0x4600000) // previosu one is 0x4600000. increase 0x1300000 under Jerry's suggestion. // go back to 0x46000000 for orange
+#else
+#define        VIDEO_DPB_SIZE         (0x7900000) // 2048*1088*1.8*27 + 2048*1088*2*3
+#endif
+#define        VIDEO_DPB_REGION       (VIDEO_STUFF_REGION - VIDEO_DPB_SIZE)
+#ifdef CONFIG_VIDEO_CPB_SIZE
+#define        VIDEO_CPB_SIZE         (CONFIG_VIDEO_CPB_SIZE * VIDEO_NUM)
+#else
+#define        VIDEO_CPB_SIZE         (0x400000 * VIDEO_NUM)
+#endif
+#define        VIDEO_CPB_REGION       (VIDEO_DPB_REGION - VIDEO_CPB_SIZE)
+#define        VIDEO_CPB_DIR_SIZE     (VIDEO_CPB_SIZE/0x100)
+#define        VIDEO_CPB_DIR_REGION   (VIDEO_CPB_REGION - VIDEO_CPB_DIR_SIZE)
+
+#ifdef CONFIG_VIDEO_ENC_NUM
+#define        VIDEO_ENC_NUM              CONFIG_VIDEO_ENC_NUM
+#else
+#define        VIDEO_ENC_NUM              0
+#endif
+
+#ifdef CONFIG_VIDEO_ENC_CPB_SIZE
+#define        VIDEO_ENC_CPB_SIZE     (CONFIG_VIDEO_ENC_CPB_SIZE * VIDEO_ENC_NUM)
+#else
+#define        VIDEO_ENC_CPB_SIZE     (0x400000 * VIDEO_ENC_NUM)
+#endif
+
+#define        VIDEO_ENC_CPB_REGION   (VIDEO_CPB_DIR_REGION - VIDEO_ENC_CPB_SIZE)
+#define        VIDEO_ENC_DIR_SIZE     (VIDEO_ENC_CPB_SIZE/0x100)
+#define        VIDEO_ENC_DIR_REGION   (VIDEO_ENC_CPB_REGION - VIDEO_ENC_DIR_SIZE)
+
+#define        VIDEO_USER_DATA_SIZE   (0x80000 * VIDEO_NUM)
+#define        VIDEO_USER_DATA_REGION (VIDEO_ENC_DIR_REGION - VIDEO_USER_DATA_SIZE)
+
+#endif
+
+#ifdef CONFIG_AUDIO_NUM
+#define        AUDIO_NUM		      CONFIG_AUDIO_NUM
+#else
+#define        AUDIO_NUM		      0
+#endif
+
+#ifdef CONFIG_AUDIO_CAB_SIZE
+#define        AUDIO_CAB_SIZE         (CONFIG_AUDIO_CAB_SIZE * AUDIO_NUM)
+#else
+#define        AUDIO_CAB_SIZE         (0x200000 * AUDIO_NUM)
+#endif
+
+#define        AUDIO_CAB_REGION	      (VIDEO_USER_DATA_REGION - AUDIO_CAB_SIZE)
+#define        AUDIO_CAB_EXT	      (AUDIO_CAB_REGION - AUDIO_ALIGN_GAP)
+#define        AUDIO_PTS_SIZE	      (AUDIO_PTS_FIXED_SIZE * (AUDIO_NUM))
+#define        AUDIO_PTS_REGION	      (AUDIO_CAB_EXT - AUDIO_PTS_SIZE)
+#define        AUDIO_PTS_EXT	      (AUDIO_PTS_REGION - AUDIO_ALIGN_GAP)
+
+#ifdef CONFIG_AUDIO_ENC_NUM
+#define 	   AUDIO_ENC_NUM          CONFIG_AUDIO_ENC_NUM
+#else
+#define        AUDIO_ENC_NUM          0
+#endif
+
+#ifdef CONFIG_AUDIO_ENC_CAB_SIZE
+#define        AUDIO_ENC_CAB_SIZE     (CONFIG_AUDIO_ENC_CAB_SIZE * AUDIO_ENC_NUM)
+#else
+#define        AUDIO_ENC_CAB_SIZE     (0x200000 * AUDIO_ENC_NUM)
+#endif
+
+#define        AUDIO_ENC_CAB_REGION	  (AUDIO_PTS_EXT - AUDIO_ENC_CAB_SIZE)
+#define        AUDIO_ENC_CAB_EXT	  (AUDIO_ENC_CAB_REGION - 0x100)
+#define        AUDIO_ENC_PTS_SIZE	  (0x6000 * (AUDIO_ENC_NUM))
+#define        AUDIO_ENC_PTS_REGION	  (AUDIO_ENC_CAB_EXT - AUDIO_ENC_PTS_SIZE)
+#define        AUDIO_ENC_PTS_EXT	  (AUDIO_ENC_PTS_REGION - 0x100)
+
+#ifdef CONFIG_AUDIO_AAB
+#define        AUDIO_AAB_SIZE	      (0x500000 * AUDIO_NUM)
+#define        AUDIO_AAB_PTS_SIZE     (0xa0000 * AUDIO_NUM)
+#define        AUDIO_AAB_REGION       (AUDIO_ENC_PTS_EXT - AUDIO_AAB_SIZE)
+#define        AUDIO_AAB_PTS_REGION   (AUDIO_AAB_REGION - AUDIO_AAB_PTS_SIZE)
+#else
+#define        AUDIO_AAB_SIZE	      (0x0)
+#define        AUDIO_AAB_PTS_SIZE     (0x0)
+#define        AUDIO_AAB_REGION       (AUDIO_ENC_PTS_EXT - AUDIO_AAB_SIZE)
+#define        AUDIO_AAB_PTS_REGION   (AUDIO_AAB_REGION - AUDIO_AAB_PTS_SIZE)
+#endif
+
+#ifdef CONFIG_CELESTIAL_FJ_RX
+#define        AUDIO_MIX_SIZE	(0x0)
+#else
+#define        AUDIO_MIX_SIZE	(0x40000)
+#endif
+#define        AUDIO_MIX_REGION	(AUDIO_AAB_PTS_REGION - AUDIO_MIX_SIZE)
+
+//disabled load firmware at TZ side
+#if 0// def CONFIG_SW_SUPPORT
+#define        AUDIO_STUFF_SIZE	(0x10000)
+#else
+#define        AUDIO_STUFF_SIZE       (0x280000)
+#endif
+#define        AUDIO_STUFF_REGION     (AUDIO_MIX_REGION - AUDIO_STUFF_SIZE)
+
+#ifdef CONFIG_AUDIO_FW_DUMP_DEBUG
+#define	     AUDIO_DEBUG_SIZE	(0x500000)
+#else
+#define        AUDIO_DEBUG_SIZE (0)
+#endif
+#define	     AUDIO_DEBUG_REGION    (AUDIO_STUFF_REGION - AUDIO_DEBUG_SIZE)
+
+#ifdef CONFIG_CELESTIAL_XPORT
+#define        XPORT_SIZE             (0xd50000)
+#else
+#define        XPORT_SIZE             (0)
+#endif
+#define        XPORT_REGION        (AUDIO_DEBUG_REGION-XPORT_SIZE)
+
+#if (defined CONFIG_SW_SUPPORT) && (defined SW_FEED_VIDEO)
+#define TZ_BOUNDARY (0x8000000)
+#else
+#define TZ_BOUNDARY (0x2000000)
+#endif
+
+#ifdef CONFIG_ANDROID_PMEM
+  #define PMEM_SIZE SZ_32M
+#else
+  #define PMEM_SIZE 0
+#endif
+
+#define PMEM_REGION (XPORT_REGION - PMEM_SIZE)
+
+#ifdef CONFIG_SW_SUPPORT
+#if (PMEM_REGION < TZ_BOUNDARY)
+#error "ERROR: Kernel memory overlap TZ reserved memory!"
+#endif
+#endif
+
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/nand.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/nand.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/nand.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/nand.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,38 @@
+/*
+ * mach-celestialsemi/include/mach/nand.h
+ */
+
+#ifndef __ARCH_ARM_CNC_NAND_H
+#define __ARCH_ARM_CNC_NAND_H
+
+#define CNC1900_SMC_CS0 (CNC1900_SMC + 0x00)
+#define CNC1900_SMC_CS1 (CNC1900_SMC + 0x0C)
+#define CNC1900_SMC_CS2 (CNC1900_SMC + 0x18)
+#define CNC1900_SMC_CS3 (CNC1900_SMC + 0x24)
+
+#define CEN_CFG_0 0x00
+#define CEN_CFG_1 0x04
+#define CEN_CFG_2 0x08
+
+#define STATUS 0x30
+#define MODE 0x38
+#define ECC_CODE 0x40
+#define ECC_COUNT 0x44
+#define ECC_ADDRESS  0x48
+
+#define MASK_ALE (1 << 22) 
+#define MASK_CLE (1 << 21)
+
+#define FORCE_CE_LOW 0x200
+#define STATUS_READY 0x001
+
+struct plat_cncnand_port {
+	phys_addr_t membase;
+	void __iomem *mapbase;
+	void __iomem *reg_port;
+	void __iomem *reg_base;
+	unsigned int cle;
+	unsigned int ale;
+};
+
+#endif	/* __ARCH_ARM_CNC_NAND_H */
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/pinmux.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/pinmux.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/pinmux.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/pinmux.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,182 @@
+/*
+ *  arch/arm/mach-celestial/include/mach/mux.h
+ *  Celestial Platform IO address definitions
+ *   
+ * This file is licensed under
+ * the terms of the GNU General Public License version 2. This program
+ * is licensed "as is" without any warranty of any kind, whether express
+ * or implied.
+ */
+
+#ifndef __MACH_MUX_H
+#define __MACH_MUX_H
+
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/vmalloc.h>
+
+#define RC_CTL_L                (0x008)    /*RC Control Register*/
+#define RC_CTL_H                (0x00a) //
+
+enum pinmux_1{
+	I2C0_EN = 0,
+	I2C1_EN,
+	VGA_OUT_EN,
+	DISP1_OUT_EN,
+};
+
+enum pinmux_disp{
+	TVE0_YPbPr = 1 ,
+	OUTIF0_RGB,
+	TVE1_CVBS_S_video,
+	TVE1_YPbPr,
+	OUTIF1_RGB,
+};
+
+typedef enum _GPIO_ID_{
+	_gpio_0     =0,
+	_gpio_1     =1,
+	_gpio_2     =2,
+	_gpio_3     =3,
+	_gpio_4     =4,
+	_gpio_5     =5,
+	_gpio_6     =6,
+	_gpio_7     =7,
+	_gpio_8     =8,
+	_gpio_9     =9,
+	_gpio_10    =10,
+	_gpio_11    =11,
+	_gpio_12    =12,
+	_gpio_13    =13,
+	_gpio_14    =14,
+	_gpio_15    =15,
+	_gpio_16    =16,
+	_gpio_17    =17,
+	_gpio_18    =18,
+	_gpio_19    =19,
+	_gpio_20    =20,
+	_gpio_21    =21,
+	_gpio_22    =22,
+	_gpio_23    =23,
+	_gpio_24    =24,
+	_gpio_25    =25,
+	_gpio_26    =26,
+	_gpio_27    =27,
+	_gpio_28    =28,
+	_gpio_29    =29,
+	_gpio_30    =30,
+	_gpio_31    =31,
+	_gpio_32    =32,
+	_gpio_33    =33,
+	_gpio_34    =34,
+	_gpio_35    =35,
+	_gpio_36    =36,
+	_gpio_37    =37,
+	_gpio_38    =38,
+	_gpio_39    =39,
+	_gpio_40    =40,
+	_gpio_41    =41,
+	_gpio_42    =42,
+	_gpio_43    =43,
+	_gpio_44    =44,
+	_gpio_45    =45,
+	_gpio_46    =46,
+	_gpio_47    =47,
+	_gpio_48    =48,
+	_gpio_49    =49,
+	_gpio_50    =50,
+	_gpio_51    =51,
+	_gpio_52    =52,
+	_gpio_53    =53,
+	_gpio_54    =54,
+	_gpio_55    =55,
+	_gpio_56    =56,
+	_gpio_57    =57,
+	_gpio_58    =58,
+	_gpio_59    =59,
+	_gpio_60    =60,
+	_gpio_61    =61,
+	_gpio_62    =62,
+	_gpio_63    =63,
+}GPIO_ID;
+
+//I2C
+typedef enum _I2C_ID_
+{
+	_i2c_0      =0,
+	_i2c_1      =1,
+}I2C_ID;
+
+int PinMuxEnableI2C(I2C_ID I2C);
+
+//IR Repeater
+typedef enum _IR_REPEATER_ID_
+{
+	_IR0      =0,
+	_IR1      =1,
+} IR_REPEATER_ID;
+
+//UART
+typedef enum _UART_ID_
+{
+	_uart_1		=1,
+	_uart_2		=2,
+	_uart_audio	=3,
+	_uart_video	=4,
+}UART_ID;
+
+//Analog Video
+typedef enum _DAC0_MODE_
+{
+	_dac0_rgb0 =0,
+	_dac0_rgb1 =1,
+	_dac0_tve0_ypbpr =2,
+	_dac0_tve0_cvbs_svideo =3,
+	_dac0_tve1_ypbpr =4,
+	_dac0_tve1_cvbs_svideo  =5,
+}DAC0_MODE;
+
+typedef enum _DAC1_MODE_
+{
+	_dac1_rgb1 = 0,
+	_dac1_tve1_ypbpr =1,
+	_dac1_tve1_cvbs_svideo  =2,
+}DAC1_MODE;
+
+//Xport
+typedef enum _XPORT_MODE_
+{
+	_xport_serial_mode	    =0,
+	_xport_paralell_mode    =1,
+} XPORT_MODE;
+
+enum pinmux_class{
+	PINMUX_I2C = 0,
+	PINMUX_UART,    // UART1/Audio_uart/Video_uart/UART2/IRDA,GPIO[6],GPIO[3],UART0,GPIO[19:18]
+	PINMUX_DISP,    // 3'b11x:OUTIF1 RGB,TVE1 YPbPr,TVE1 CVBS+S-video,OUTIF0 RGB,TVE0 YPbPr
+	PINMUX_SMI,     // GPIO[31:27] ,SMI
+	PINMUX_TS,      // xport 1
+	PINMUX_DVIO,    // 1800H GPIO[40:32],digital video input / 1800L GPIO[63:40],digital video input
+	PINMUX_SDIO,    // SDIO / GPIO [39:32]
+};
+
+/* function declaration ------------------------------------- */
+int pinmux_scan_status_bit(int  mode);
+int pinmux_set_status_bit(int  mode, int bit, int set);
+int pinmux_get_status_bit(int  mode,int bit);
+int pinmux_update_fpc_status(void);
+int pinmux_update_rc_status(void);
+int pinmux_set_xportmode(XPORT_MODE Mode);
+int pinmux_enable_uart(UART_ID UART);
+int pinmux_enable_i2c(I2C_ID I2C);
+int pinmux_enable_ir_repeater(IR_REPEATER_ID IR);
+int pinmux_enable_irda(void);
+int pinmux_enable_spi(void);
+int pinmux_enable_smi(void);
+int pinmux_enable_vib(void);
+int pinmux_enable_ttlout(void);
+int pinmux_set_dac0mode(DAC0_MODE Mode);
+int pinmux_set_dac1mode(DAC1_MODE Mode);
+
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/smc.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/smc.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/smc.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/smc.h	2014-08-25 16:45:04.079934000 +0800
@@ -0,0 +1,46 @@
+#ifndef __SMC_H__
+#define __SMC_H__
+
+#if defined(__GNUC__) && \
+    defined(__GNUC_MINOR__) && \
+defined(__GNUC_PATCHLEVEL__) && \
+((__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)) \
+> 40700
+#define USE_ARCH_EXTENSION_SEC 1
+#else
+#define USE_ARCH_EXTENSION_SEC 0
+#endif
+
+
+#define SMC_CMD_L2X0CTRL	(-21)
+#define SMC_CMD_L2X0SETUP1	(-22)
+#define SMC_CMD_L2X0SETUP2	(-23)
+
+#define SMC_CMD_VIDEO_WIRTE_REG	(-110)
+#define SMC_CMD_VIDEO_READ_REG  (-111)
+#define SMC_CMD_AUDIO_WIRTE_REG	(-112)
+#define SMC_CMD_AUDIO_READ_REG  (-113)
+#define SMC_CMD_VIDEO_WIRTE_IRQ_REG	(-114)
+#define SMC_CMD_VIDEO_READ_IRQ_REG  (-115)
+
+#ifndef __ASSEMBLY__
+static inline u32 sw_smc(u32 cmd, u32 arg1, u32 arg2, u32 arg3)
+{
+	register u32 reg0 __asm__("r0") = cmd;
+	register u32 reg1 __asm__("r1") = arg1;
+	register u32 reg2 __asm__("r2") = arg2;
+	register u32 reg3 __asm__("r3") = arg3;
+
+	__asm__ volatile (
+#ifdef USE_ARCH_EXTENSION_SEC
+		".arch_extension sec\n\t"
+#endif
+		"smc	0\n"
+		: "+r"(reg0), "+r"(reg1), "+r"(reg2), "+r"(reg3)
+	);
+
+	return reg0;
+}
+#endif
+
+#endif //__SMC_H__
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/timex.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/timex.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/timex.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/timex.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,27 @@
+/*
+ * arch/arm/mach-celestialsemi/include/mach/timex.h
+ *
+ *  Copyright (C) 2003 Xiaodong Fan
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef __ASM_ARCH_TIMEX_H
+#define __ASM_ARCH_TIMEX_H
+
+#define PCLK_FREQ 810000000
+#define CLOCK_TICK_RATE (100 * HZ)
+
+#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/uncompress.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/uncompress.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/uncompress.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/uncompress.h	2014-11-19 00:25:03.684040000 +0800
@@ -0,0 +1,58 @@
+/*
+ *  arch/arm/mach-celestial/include/mach/uncompress.h
+ *
+ *  Copyright (C) 2010 Celestial
+ *   xiaodong.fan@celestialsemi.com
+  *  Copyright (C) 2012 Cavium
+ *   xiaodong.fan@cavium.com
+*  
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+
+#include <linux/types.h>
+#include <linux/serial_reg.h>
+#include <mach/hardware.h>
+
+/*
+ * This does not append a newline
+ */
+
+#ifndef CONFIG_UNCOMPRESS_QUIET
+static volatile u32 *uart = (u32 *)CNC1900_UART0;
+#endif
+
+static inline void putc(int c)
+{
+#ifndef CONFIG_UNCOMPRESS_QUIET
+	while (!(uart[UART_LSR] & UART_LSR_THRE))
+		barrier();
+	uart[UART_TX] = c;
+#endif
+}
+
+static inline void flush(void)
+{
+#ifndef CONFIG_UNCOMPRESS_QUIET
+	while (!(uart[UART_LSR] & UART_LSR_THRE))
+	barrier();
+#endif
+}
+
+/*
+ * nothing to do
+ */
+#define arch_decomp_setup()
+#define arch_decomp_wdog()
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/usb.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/usb.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/usb.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/usb.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,16 @@
+/*
+ *  arch/arm/mach-celestial/include/mach/usb.h
+ *
+ *
+ *  Copyright (C) 2012 Cavium
+ */
+
+#ifndef __ASM_ARCH_USB_H
+#define __ASM_ARCH_USB_H
+
+#include <linux/usb/g_hid.h>
+
+extern int platform_add_usb_hid_device(int device_type, struct hidg_func_descriptor *func_descriptor);
+extern int platform_remove_usb_hid_device(int device_type);
+
+#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/Kconfig linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/Kconfig
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/Kconfig	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/Kconfig	2014-11-19 00:25:03.684040000 +0800
@@ -0,0 +1,58 @@
+menu "Cavium Celestial platform type"
+choice
+	prompt "Celestial platform Series SoC Version"
+	depends on ARCH_CELESTIAL
+	default MACH_CELESTIAL_CNC1900
+
+config MACH_CELESTIAL_CNC1900
+	bool "Cavium Celestial CNC1900"
+	help
+	  Include support for the Cavium Celestial CNC1900 platform.
+
+endchoice
+
+config PUREVU
+	bool "Support for PUREVU"
+	depends on MACH_CELESTIAL_CNC1900
+	default y
+	help
+	  Enable support for PUREVU.
+config UNCOMPRESS_QUIET
+	bool "Quiet when uncompress the kernel"
+	depends on MACH_CELESTIAL_CNC1900
+	default n
+	help
+	  Not output to UART0 when uncompress from zImage
+
+choice
+	prompt "CNC1900 Series Boards"
+	depends on MACH_CELESTIAL_CNC1900
+	default CELESTIAL_HDK
+
+config CELESTIAL_EVB
+	bool "Config for Celestial EVB board"
+        help
+          If select this option, will use memory defines for EVB board
+
+config CELESTIAL_HDK
+	bool "Config for Celestial HDK board"
+        help
+          If select this option, will use memory defines for HDK board
+
+config CELESTIAL_FJ_TX
+	bool "Config for Celestial FJ TX board"
+        help
+          If select this option, will use memory defines for FJ_TX board
+
+config CELESTIAL_FJ_RX
+	bool "Config for Celestial FJ RX board"
+        help
+          If select this option, will use memory defines for FJ_RX board
+
+config CELESTIAL_OTT_EMMC
+	bool "Config for Celestial OTT_EMMC board"
+        help
+          If select this option, will use memory defines for OTT_EMMC board
+endchoice
+
+endmenu
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/Makefile linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/Makefile
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,7 @@
+#
+# Makefile for the linux kernel.
+#
+
+obj-$(CONFIG_ARCH_CELESTIAL) += cnc19xx.o clock.o timer.o cnc1900_power_clk.o pinmux.o usb.o pmem.o nap.o cnc1900_cpufreq_plat.o cnc19xx_mem_info.o
+obj-$(CONFIG_HOTPLUG_CPU)    += hotplug.o
+obj-$(CONFIG_SMP)            += platsmp.o
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/Makefile.boot linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/Makefile.boot
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/Makefile.boot	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/Makefile.boot	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,4 @@
+   zreladdr-y	:= 0x00008000
+params_phys-y	:= 0x00000100
+initrd_phys-y	:= 0x00800000
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/nap.S linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/nap.S
